
/* $Id: t2_acomm.h,v 1.3 2000/12/02 02:10:43 chialin Exp $ */

/* t2_acomm.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 1/4/98
 * Inter-processor communication definitions.
 */

#ifndef _T2_ACOMM_H_
#define _T2_ACOMM_H_


/*
 * Use MPI communication library.
 */
#ifdef T2_MPI_COMM

	#include	<limits.h>
	#include	<mpi.h>

	struct T2_CommControlBlock {
	public:
		size_t	    nbytes;		/* number of bytes sent */
		MPI_Request request;
		MPI_Status  status;

		T2_CommControlBlock(): nbytes(UINT_MAX) {};
	};

	#define T2_AnyTag	MPI_ANY_TAG
	#define T2_AnySource	MPI_ANY_SOURCE

#endif		/* T2_MPI_COMM */



/*
 * Use PVM communication library.
 */
#ifdef T2_PVM_COMM

	#include	<pvm3.h>

#endif		/* T2_PVM_COMM */


#endif		/* _T2_ACOMM_H_ */
