
/* $Id: t2_commtags.h,v 1.5 2000/03/16 00:43:05 chialin Exp $ */

/* t2_commtags.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 7/6/98
 * The definitions of various message tags used by T2.
 */


#ifndef _T2_COMMTAGS_H_
#define _T2_COMMTAGS_H_


/* tags used by the back-end for communication purpose */
const int
  T2_BECollectQPlanMsgSizeTag	= 5600,
  T2_BEQPlanBlockInfoTag	= 5601,
  T2_BEReturnQPlanMsgSizeTag	= 5602,
  T2_BEQPrePlanTag		= 5603;

/* tags used by T2_Comm for the various phases */
const int
/*
  T2_InitMsgTag			= 6700,
  T2_ReduceMsgTag		= 6710,
  T2_CombineMsgTag		= 6720,
*/
  T2_AccMsgDataTag		= 9000;
/* NOTE: I am using T2_AccMsgDataTag+i as the accumulator msg tag for query i,
 * and T2_AccMsgDataTag-i-1 as the msg tag for a T2 msg to kill query i on
 * a remote processor, therefore there cannot be any other msg tag that are 
 * near T2_AccMsgDataTag.
 */



#endif	/* ! _T2_COMMTAGS_H_ */
