
/* t2_outsock.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 8/5/98
 * A class for handling a list of nonblocking sockets.
 */


#ifndef _T2_OUTSOCK_H_
#define _T2_OUTSOCK_H_


#include	"t2_header.h"
#include	"t2_tset.h"
#include	"t2_outhandle.h"
#include	"t2_work.h"


/////////////////////////////////////////////////////////////////////////////
//
// T2_OutputSock
//
/////////////////////////////////////////////////////////////////////////////
class T2_OutputSock {
public:
  T2_OutputSock(u_int l=0);		// l is max set size
  ~T2_OutputSock() { t2_Assert (isEmpty() == true); };

  // query methods
  u_int getNumberOutputs() const { return outsocks.getNumberElements(); };
  u_int getMaxNumberOutputs() const { return outsocks.getMaxSetSize(); };
  bool isEmpty() const { return outsocks.isEmpty(); };
  bool isFull() const { return outsocks.isFull(); };

  // set maxset size
  void clear(u_int l) { outsocks.clear(l); };

  // register an T2_OHSocket; return true if succeeds, false otherwise
  bool registerOHSocket(T2_OHSocket& s) { return outsocks.in(&s); };

  // poll for writes
  void poll(T2_WorkList& wlist);

protected:
  T2_TSet<T2_OHSocket*> outsocks;

private:
};


inline
T2_OutputSock::T2_OutputSock(u_int l): outsocks(l)
{
}



#endif	/* ! _T2_OUTSOCK_H_ */
