
/* t2_sockdefs.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 7/10/98
 * general definitions for sock.c
 */


#ifndef _T2_SOCKDEFS_H_
#define _T2_SOCKDEFS_H_

#include        <stdio.h>
#include        <stdlib.h>
#include	<unistd.h>
#include	<errno.h>
#include        <string.h>
#include        <strings.h>
#include        <sys/types.h>
#include        <sys/socket.h>
#include	<netinet/in.h>
#include        <arpa/inet.h>
#include	<netdb.h>
#include        <fcntl.h>
#include	<sys/select.h>
#include	<sys/time.h>



/**
 * some defines
 **/

#ifndef INET_ADDRSTRLEN
  #define INET_ADDRSTRLEN	16	/* ddd.ddd.ddd.ddd\0 */
#endif

#ifndef INET6_ADDRSTRLEN
  #define INET6_ADDRSTRLEN	46	/* max size of IPv6 address string */
#endif


#ifndef T2_SYS_SUPPORT_SOCKLEN_T
  #ifdef T2_SOCKLEN_T_INT
	typedef int socklen_t;
  #else
	typedef size_t socklen_t;
  #endif
#endif


/*
 * define C prototypes here
 */

#ifdef __cplusplus
  extern "C" {
#endif


/* #ifndef T2_SYS_SUPPORT_INET_PTON		*/
  int
  inet_pton(int family, const char* strptr, void *addrptr);
/* #endif */	/* ! T2_SYS_SUPPORT_INET_PTON */

/* #ifndef T2_SYS_SUPPORT_INET_NTOP		*/
  const char*
  inet_ntop(int family, const void* addrptr, char* strptr, size_t len);
/* #endif */	/* ! T2_SYS_SUPPORT_INET_NTOP */

char*
sock_ntop(const struct sockaddr *sa, socklen_t salen);

void
printhostent(struct hostent *hptr);

int
testFcntlFlag(int fd, int feature),
setFcntlFlag(int fd, int feature),
unsetFcntlFlag(int fd, int feature);


#ifndef T2_SYS_SUPPORT_HSTRERROR
  const char* hstrerror(int);
#endif


#ifndef T2_SYS_SUPPORT_USLEEP
  int usleep(u_int);
#endif


#ifdef __cplusplus
  }
#endif


/*
 * define C++ prototypes here
 */
#ifdef __cplusplus


#endif	/* __cplusplus */



#endif	/* ! _T2_SOCKDEFS_H_ */
