
/* bstream.C */

#include	<ctype.h>
#include	<string.h>
#include	<errno.h>
#include	"t2_bstream.h"


/////////////////////////////////////////////////////////////////////////////
//
// T2_IBStream methods
//
/////////////////////////////////////////////////////////////////////////////
T2_IBStream &
T2_IBStream::operator >> (char* s)
{
  if (s == NULL) {
     setErr(EINVAL);
     return *this;
  }

  // skip blanks first
  ssize_t r;
  while ((r = bread(s, 1, sizeof(char))) > 0 && isspace(*s));
  if (r <= 0)					// something went wrong !!
     return *this;

  s++;

  // assuming nobody would read more than maxlen bytes
  const u_int maxlen = 100000;

  for (u_int i=0; i<maxlen; i++, s++) {
    if (bread(s, 1, sizeof(char)) <= 0) {	// something went wrong !!
	*s = '\0';
	return *this;
    }

    if (isspace(*s) || *s == '\0') {		// done !!
	setErr(0);
	*s = '\0';
	return *this;
    }
  }

  t2_err_quit(__FILE__, __LINE__,
	      "More than %d bytes were read for a string", maxlen);
  setErr(EOVERFLOW);
  return *this;
}



/////////////////////////////////////////////////////////////////////////////
//
// T2_OBStream methods
//
/////////////////////////////////////////////////////////////////////////////
T2_OBStream &
T2_OBStream::operator << (char* s)
{
  if (s == NULL)
     return *this;

  u_int l = strlen(s);
  bwrite(s, l+1, sizeof(char));			// include '\0' at the end
  return *this;
}
