
/* $Id: svm_dataset.h,v 1.3 2000/02/14 19:37:39 chialin Exp $ */

/* svm_dataset.h */


#ifndef _SVM_DATASET_H_
#define _SVM_DATASET_H_


#include	<iostream.h>
#include	"t2_dataset.h"
#include	"svm_image.h"


///////////////////////////////////////////////////////////////////////
//
// svm_ImageDataset
//
///////////////////////////////////////////////////////////////////////
class svm_ImageDataset: public T2_Dataset {
public:
  svm_ImageDataset(u_int w, u_int h, u_int s,  u_int v);
  virtual ~svm_ImageDataset() {};

  // virtual methods
  virtual T2_UDFRet genIterator(const T2_System& system, T2_IteratorID i,
			       const T2_Cluster& c,
			       const T2_Box& mbr, T2_ClusterAuxInfoReader& meta,
			       const T2_Box& iqr, const T2_Region& oqw,
			       T2_ProjectFuncObj& prj, T2_Iterator*& iterp);

  // query methods
  u_int getWidth() const { return width; };
  u_int getHeight() const { return height; };
  u_int getPixelSize() const { return pixelsize; };
  u_int getMaxValue() const { return maxval; };

protected:
  u_int width, height, 		// width and height of the image
	pixelsize,		// number of bytes per pixel
	maxval;			// max color value per pixel

private:
};


inline
svm_ImageDataset::svm_ImageDataset(u_int w, u_int h, u_int s, u_int v)
			: width(w), height(h), pixelsize(s), maxval(v)
{
}



///////////////////////////////////////////////////////////////////////
//
// svm_ImageDatasetIterator
//
///////////////////////////////////////////////////////////////////////
class svm_ImageDatasetIterator: public svm_ImageIterator, public T2_Iterator {
public:
  svm_ImageDatasetIterator(u_int x_p, u_int y_p, u_int w, u_int h, u_int psize,
			   u_char* b, u_int x_s, u_int y_s,
			   u_int x_e, u_int y_e);
  virtual ~svm_ImageDatasetIterator() {};

  // virtual methods
  virtual T2_UDFRet getNextElement(const T2_System& system, const T2_Cluster& c,
				   bool& eod, const void*& e, T2_Point& coord);

protected:
  u_int x_pos, y_pos;		// coordinates of the first pixel in the cluster
  svm_ImagePixel pixel;		// an object to host the pixel to be returned

private:
};


inline
svm_ImageDatasetIterator::
svm_ImageDatasetIterator(u_int x_p, u_int y_p, u_int w, u_int h, u_int psize,
		 	 u_char* b, u_int x_s, u_int y_s, u_int x_e, u_int y_e)
		: svm_ImageIterator(w, h, psize, b, x_s, y_s, x_e, y_e),
		  T2_Iterator(), x_pos(x_p), y_pos(y_p), pixel()
{
}



#endif	/* _SVM_DATASET_H_ */
