
/* $Id: dld-stdfunc.C,v 1.4 1999/03/27 22:59:48 chialin Exp $ */

/* dld-stdfunc.C */


#include	"t2dld_stdfunc.h"
#include	"t2dld_hilbert.h"

//////////////////////////////////////////////////////////////////////////
//
// T2DLD_STDGetClustersFunc methods
//
//////////////////////////////////////////////////////////////////////////
bool
T2DLD_STDGetClustersFunc::init(const char* index_file)
{
  index.open(index_file);
  if (!index)
     return false;
  return true;
}


u_int
T2DLD_STDGetClustersFunc::getNumberDimensions()
{
  return index.getMBRNumberDimensions();
}


void
T2DLD_STDGetClustersFunc::getClusters(T2DLD_TapeClusterArray& c)
{
  if (read_index == false) {
     index.read(c);
     read_index = true;		// make sure only read index file once
  }
}



//////////////////////////////////////////////////////////////////////////
//
// t2dld_stdGetClustersFunc()
//
//////////////////////////////////////////////////////////////////////////
T2DLD_GetClustersFuncObj*
t2dld_stdGetClustersFunc()
{
  return (T2DLD_GetClustersFuncObj *) new T2DLD_STDGetClustersFunc();
}



//////////////////////////////////////////////////////////////////////////
//
// T2DLD_RoundRobinPlacement methods
//
//////////////////////////////////////////////////////////////////////////
bool T2DLD_RoundRobinPlacement::
placeClusters(const T2DLD_DataClusterArray& clusters,
              T2_Array<T2DLD_MoverInstruction>& mover_instr)
{
  t2_Assert (mover_instr.getNumberElements() > 0);
  u_int cur_disk = 0;

  for (u_int i=0; i<clusters.getNumberDataClusters(); i++) {
     t2_Assert (clusters[i] != NULL);
     mover_instr[cur_disk] << clusters[i];
     if (++cur_disk == mover_instr.getNumberElements())
        cur_disk = 0;
  }
  return true;
}



//////////////////////////////////////////////////////////////////////////
//
// t2dld_stdPlacementFunc()
//
//////////////////////////////////////////////////////////////////////////
T2DLD_PlacementFuncObj*
t2dld_stdPlacementFunc()
{
//  return (T2DLD_PlacementFuncObj *) new T2DLD_RoundRobinPlacement();

  return (T2DLD_PlacementFuncObj *) new T2DLD_Hilbert3D();
}

