/*
  File name: t2mc_types.H

  Types for Meta-Chaos communication in T2. 
*/
#ifndef T2MC_TYPES_H
#define T2MC_TYPES_H

#include "data_types.H"

typedef DATA_Type  T2_DataType;

// Communication types. 
enum T2_OutputType {
  T2_OUT_MC_COMM    = 100,
  T2_OUT_MC_OFFBAND = 101,
  T2_OUT_SOCKET     = 102,
  T2_OUT_FILE       = 103,

  T2_OUT_UNKNOWN = -1
};

enum T2_InputType {
  T2_INP_MC_COMM    = 200,
  T2_INP_MC_OFFBAND = 201,
  T2_INP_SOCKET     = 202,
  T2_INP_FILE       = 203,
  
  T2_INP_UNKNOWN = -2
};

#endif /* T2MC_TYPES_H */
