#ifndef __communication__
#define __communication__

#include "util.h"
#include "global.h"
#include "zm.h"
#include "liste.h"
#include "pgme.h"
#include "schedule.h"
#include "sd.h"
#include "regionX.h"
#include "regionHpf.h"
#include "regionEnum.h"

#define FLAG_REQUETE      1000
#define FLAG_SCHEDULE     1001
#define FLAG_Broadcast1   1002
#define FLAG_Broadcast2   1003


#ifdef __cplusplus
  extern "C" {
#endif


void pvm_pack_ZM
_AnsiC_((
	 ZM_s *zm
	 ));

ZM_s *pvm_unpack_ZM
_AnsiC_((
	 ZM_s *zm
	 ));

void SendListe
_AnsiC_((
	 liste_s   *liste,
	 TID       tid,
	 TmsgTag   msgTag,
	 void (*pack)(ZM_s*)
	 ));

liste_s *
RecvListe
_AnsiC_((
	 TID       tid,
	 TmsgTag    msgTag,
	 ZM_s *(*unpack)(ZM_s*),
	 int  sizeOfUnpackedElement
	 ));

void SendSched
_AnsiC_((
	 pgme_s *pgme,
	 int to,
	 sched_s *sched,
	 int tag
	 ));

sched_s *RecvSched
_AnsiC_((
	 pgme_s *computesched_pgme,
	 sched_s *sched,
	 int tag
	 ));

void 
pvm_pack_SD
_AnsiC_((
	 SD_s *sd
	 ));

SD_s *
pvm_unpack_SD
_AnsiC_((
	 SD_s *sd
	 ));


void BroadcastSetOfRegion
_AnsiC_((
	 setOfRegion_s *setOfRegion,
	 pgme_s *other_pgme
	 ));

setOfRegion_s *RecvSetOfRegion
_AnsiC_((
	 pgme_s *other_pgme
	 ));

void BroadcastRegion
_AnsiC_((
	 region_s *region,
	 pgme_s *other_pgme
	 ));

void pvm_pack_RegionEnum
_AnsiC_((
	 region_enum_s *region
	 ));

region_enum_s *pvm_rcv_RegionEnum
_AnsiC_((
	 TID            tid,
	 TmsgTag        tag
	 ));

void pvm_pack_RegionHPF
_AnsiC_((
	 region_hpf_s *region
	 ));

region_hpf_s *pvm_rcv_RegionHPF
_AnsiC_((
	 TID            tid,
	 TmsgTag        tag
	 ));


#ifdef __cplusplus
  }
#endif


#endif
