#include <stdio.h>

#include "compute_schedule.h"
#include "liste.h"
#include "schedule.h"
#include "requete.h"
#include "regionX.h"
#include "pgme.h"
#include "communication.h"

int optimization_is_on=1;

void SetGlueOptOn()
{
  optimization_is_on=0;
}

void
ComputeSchedule(pgme                 ,
		DADsender            ,
		setOfRegionSender    ,
		LocalDereference     ,
		DADreceiver          ,
		setOfRegionReceiver  ,
		GlobalDereference    ,
		sched_send           ,
		sched_recv 
		)
pgme_s             *pgme                  ;
DataRepresentation *DADsender             ;
setOfRegion_s      *setOfRegionSender     ;
liste_s            *(*LocalDereference )();
DataRepresentation *DADreceiver           ;
setOfRegion_s      *setOfRegionReceiver   ;
liste_s            *(*GlobalDereference)();
sched_s            **sched_send           ;
sched_s            **sched_recv           ;
{
  int i;
  liste_s *liste_of_zm_for_the_set=NULL;
  liste_s *liste_of_zm_for_region=NULL;
  sched_s            *pt_sched_send;
  sched_s            *pt_sched_recv;

  liste_of_zm_for_the_set=AllocListe();
  for (i=0;i<setOfRegionSender->NumRegion;i++)
    {liste_of_zm_for_region=
       (*LocalDereference)(DADsender,
			   setOfRegionSender->regions[i],
			   setOfRegionSender->BeginGlobalOffset[i]); 
     liste_of_zm_for_the_set=
       MoveListe(liste_of_zm_for_the_set,
		 liste_of_zm_for_region);
   }


  compress_liste_zm(liste_of_zm_for_the_set);

  traitement_requete_locale(liste_of_zm_for_the_set,
			    DADreceiver,
			    setOfRegionReceiver,
			    pgme,
			    GlobalDereference,
			    sched_send,
			    sched_recv
			    );

  pt_sched_send=*sched_send;
  pt_sched_recv=*sched_recv;
  compress_schedule(pt_sched_send);
  compress_schedule(pt_sched_recv);
}


sched_s *
ComputeScheduleForSender
(
 wtc,
 sender_pgme,
 DAD,              
 setOfRegion,             
 other_pgme,              
 ArrayDereferenceFct,
 ResponsableFct,
 knownAboutOtherPgmeData,
 optComm
 )
WhereToCompute      wtc               ;
pgme_s             *sender_pgme       ;
DataRepresentation *DAD               ;
setOfRegion_s      *setOfRegion       ;
pgme_s             *other_pgme        ;
liste_s *(    *ArrayDereferenceFct )();
int      (         *ResponsableFct )();
void          *knownAboutOtherPgmeData;
T_OptimiseComm      optComm           ;
{
  liste_s *liste_of_zm_for_the_set=NULL;
  liste_s *liste_of_zm_for_region=NULL;
  sched_s *sched=NULL;
  int i;

  liste_of_zm_for_the_set=AllocListe();
  for (i=0;i<setOfRegion->NumRegion;i++)
    {liste_of_zm_for_region=
       (*ArrayDereferenceFct)(DAD,
			 setOfRegion->regions[i],
			 setOfRegion->BeginGlobalOffset[i]); 
     liste_of_zm_for_the_set=
       MoveListe(liste_of_zm_for_the_set,
		 liste_of_zm_for_region);
     /* attention: liste_of_zm_for_region est detruite 
        y compris la tete 
     */
   }

  compress_liste_zm(liste_of_zm_for_the_set);

  emission_requete(liste_of_zm_for_the_set,
		   setOfRegion,
		   other_pgme,
		   ResponsableFct,
		   knownAboutOtherPgmeData);

  sched=ReceiveSchedule(other_pgme);
  return(sched);  
}

sched_s *
ComputeScheduleForReceiver
(
 wtc,
 receiver_pgme,
 DAD,              
 setOfRegion,             
 other_pgme,              
 ArrayDereferenceFct,  
 optComm     
 )
WhereToCompute      wtc                     ;
pgme_s             *receiver_pgme           ;
DataRepresentation *DAD                     ;
setOfRegion_s      *setOfRegion             ;
pgme_s             *other_pgme              ;
liste_s *(         *ArrayDereferenceFct)()  ;
T_OptimiseComm      optComm                 ;
{
  liste_s *liste_requete_zm=NULL;
  sched_s *sched=NULL;

  liste_requete_zm=
    reception_requete(other_pgme);

  traitement_requete(liste_requete_zm,
		     DAD,
		     setOfRegion,
		     receiver_pgme,
		     other_pgme,
		     ArrayDereferenceFct,
		     optComm
		     );

  /* attention: 
     la liste liste_requete_zm n existe plus 
  */

  sched=ReceiveSchedule(receiver_pgme);
  return(sched);
}

sched_s *
ComputeGetScheduleForSender(
			    wtc                ,
			    sender_pgme        ,
			    DAD                ,
			    other_pgme         ,
			    ArrayDereferenceFct,
			    ResponsableFct     ,
			    optComm
			    )
	 WhereToCompute      wtc               ;
	 pgme_s             *sender_pgme       ;
	 DataRepresentation *DAD               ;
	 pgme_s             *other_pgme        ;
	 liste_s *(    *ArrayDereferenceFct )();
  	 int      (         *ResponsableFct )();
	 T_OptimiseComm      optComm           ;
{
  sched_s *sched;
  setOfRegion_s *setOfRegion;
  int knownAboutOtherPgmeData;
             
  setOfRegion=RecvSetOfRegion(other_pgme);
  knownAboutOtherPgmeData=SizeSetOfRegion(setOfRegion);
  sched=ComputeScheduleForSender(
				 wtc,sender_pgme,DAD,setOfRegion,             
				 other_pgme,
				 ArrayDereferenceFct,ResponsableFct,
				 &knownAboutOtherPgmeData, optComm
				 );
  Free_setOfRegion(setOfRegion);
  return(sched);
}

sched_s *
ComputeGetScheduleForReceiver(
			      wtc                ,
			      receiver_pgme      ,
			      DAD                ,
			      mySetOfRegion      ,
			      other_pgme         ,
			      OtherSetOfRegion   ,
			      ArrayDereferenceFct,
			      optComm  
			      )      
     WhereToCompute      wtc               ;         
     pgme_s             *receiver_pgme     ;
     DataRepresentation *DAD               ;
     setOfRegion_s      *mySetOfRegion     ;
     pgme_s             *other_pgme        ;
     setOfRegion_s      *OtherSetOfRegion  ;
     liste_s *(    *ArrayDereferenceFct )();
     T_OptimiseComm      optComm           ;
{
  sched_s *sched;
  
  BroadcastSetOfRegion(OtherSetOfRegion,other_pgme);
  sched=ComputeScheduleForReceiver(
				   wtc,
				   receiver_pgme,
				   DAD,              
				   mySetOfRegion,
				   other_pgme,
				   ArrayDereferenceFct,
				   optComm     
				   );
  return(sched);
}
