
#include <stdio.h>
#include <string.h>
#include "pgme.h"
#include "pvm3.h"
#include "util.h"

pgme_s *my_pgme__=NULL;
int    joinedAnyPgme=0;
char   AnyPgmeName[]="XYZ123__";

pgme_s *InitPgme(nom,numnode)
     char *nom;
     int numnode;
{pgme_s *pgme;
 TID mytid;
 int i;
 int me = 0; /* TAHSIN commented out : parti_pvm_mynode() ; */


#ifdef _verbose_flag_on_
 /* TAHSIN */
 printf("ME = %d\n",me);
 fflush(stdout);
#endif

 _affirmation_(("numnode>0",numnode>0));
 pgme=Malloc_s(pgme_s);
 pgme->nbNode=numnode;
 pgme->name=(char *)malloc(strlen(nom)+1);
 sprintf(pgme->name,"%s",nom);
 pgme->tid=(TID *)malloc(sizeof(TID)*numnode);

 mytid=pvm_mytid();

 if (me==0)
   pvm_joingroup(nom);
 else
   {while (pvm_gsize(nom)!=me) sleep(1);
    pvm_joingroup(nom);
  }

 pvm_barrier(nom,numnode);
 
 pgme->myPos=-1;
 for (i=0;i<numnode;i++)
   {pgme->tid[i]=pvm_gettid(nom,i);
    if (mytid==pgme->tid[i]) pgme->myPos=i;
#ifdef _verbose_flag_on_
    if (mytid==pgme->tid[i] && me!=i)
      warning("en utilisant l initialization de Bongki"); 
#endif 
  }

 pvm_barrier(nom,numnode);
 my_pgme__=pgme;

#if 0
 pvm_setopt(PvmRoute,PvmRouteDirect);
#endif 
 pvm_setopt(PvmRoute,PvmDontRoute);
 pvm_setopt(PvmFragSize,GlueFragBuffer);

 PrintPgme(my_pgme__);

 return(pgme);
}

pgme_s *InitPgmeMe(name,numnode,me)
char *name;
int numnode;
int me;
{
  char name1[100];
  pgme_s *pgme;
  TID mytid;
  int i;

  _affirmation_(("numnode>0",numnode>0));
  sprintf(name1,"%s_1",name);

  pgme=Malloc_s(pgme_s);
  pgme->nbNode=numnode;
  pgme->name=(char *)malloc(strlen(name)+1);
  sprintf(pgme->name,"%s",name);
  pgme->tid=(TID *)malloc(sizeof(TID)*numnode);

  mytid=pvm_mytid();
  pvm_joingroup(name1);
  pvm_barrier(name1,numnode);

  while (pvm_gsize(name)!=me) 
    {
      if (me==0 && pvm_gsize(name)<0) break;
      sleep(1);
    }
    ;

  pvm_joingroup(name);
  pvm_barrier(name,numnode);

  pgme->myPos=-1;
  for (i=0;i<numnode;i++)
    {pgme->tid[i]=pvm_gettid(name,i);
     if (mytid==pgme->tid[i]) pgme->myPos=i;
#ifdef _verbose_flag_on_
     if (mytid==pgme->tid[i] && me!=i)
       warning("en utilisant l initialization de Bongki"); 
#endif 
   }

#if 0
  pvm_setopt(PvmRoute,PvmRouteDirect);
#endif 
  pvm_setopt(PvmRoute,PvmDontRoute);
  pvm_setopt(PvmFragSize,GlueFragBuffer);

  my_pgme__=pgme;

#if _verbose_flag_on_
  printf("\n pgme name= [%s] has begun on [%i] Node, I am [%i]\n",
	 name,NumNodeMyPgme(),MyPosMyPgme() );
#endif 

  return(pgme);
}

pgme_s *WaitPgme(nom,numnode)
     char *nom;
     int numnode;
{pgme_s *pgme;
 int i;
 _affirmation_(("numnode>0",numnode>0));
 pgme=Malloc_s(pgme_s);
 pgme->nbNode=numnode;
 pgme->name=(char *)malloc(strlen(nom)+1);
 sprintf(pgme->name,"%s",nom);
 pgme->tid=(TID *)malloc(sizeof(TID)*numnode);
 pgme->myPos=-1;

 while (pvm_gsize(nom)!=numnode) {
#ifdef _verbose_flag_on_
   fprintf(stderr,"%i %d\n",pvm_gsize(nom), numnode);
#endif 
   sleep(1);
 }

#ifdef _verbose_flag_on_
 fprintf(stderr,"%i \n",pvm_gsize(nom));
 fprintf(stderr,"%i \n",pvm_gsize(nom));
#endif 

 for (i=0;i<numnode;i++)
   pgme->tid[i]=pvm_gettid(nom,i);
 return(pgme);
}

/*
 * Added by Tahsin Kurc. 
 *
 * This function checks if a program is ready. It returns 1 
 * if the other program is ready, 0 otherwise. 
 *
 */
int CheckPgme(nom,numnode)
     char *nom;
     int  numnode;
{
  if (pvm_gsize(nom)==numnode) 
    return 1;
  return 0;
}

int MyPosPgme(pgme)
pgme_s *pgme;
{
  return(pgme->myPos);
}

TID MyTidPgme(pgme)
pgme_s *pgme;
{if (pgme->myPos==-1)
   return(-1);
 return(TidPgme(pgme,pgme->myPos));
}

TID TidPgme(pgme,num)
pgme_s *pgme;
int num;
{
 _affirmation_(("pgme!=NULL",pgme!=NULL));
 _affirmation_(("pgme->nbNode>num",pgme->nbNode>num));
 return((pgme->tid)[num]);
}

int NumNodePgme(pgme)
     pgme_s *pgme;
{
  return(pgme->nbNode);
}

void FreePgme(pgme)
pgme_s *pgme;
{
  if (pgme==NULL) 
    return;

  pvm_lvgroup(pgme->name);
    
  free(pgme->name);
  free(pgme->tid);
  free(pgme);
}

/*
void fsyncanypgme_(num)
int *num;
{
  SyncAnyPgme(*num);
}

void SyncAnyPgme(num)
int num;
{
  if (joinedAnyPgme==0)
    {
      pvm_joingroup(AnyPgmeName);
      joinedAnyPgme++;
    }
  pvm_barrier(AnyPgmeName,num);
}
*/


void SyncPgme(pgme)
     pgme_s *pgme;
{
/*
  int i;
  pvm_initsend(GlueEncoding);
  for (i=0;i<NumNodePgme(pgme);i++)    
    {
      if (i!=MyPosPgme(pgme))
	{
	fprintf(stderr,"\n mytid=%i sending to %i \n",pvm_mytid(),TidPgme(pgme,i));
	pvm_send(TidPgme(pgme,i),1007);        
      }
    }
  for (i=0;i<NumNodePgme(pgme)-1;i++)    
    {pvm_recv(-1,1007);        
   }
*/  

  int i;
  pvm_initsend(GlueEncoding);
  pvm_send(TidPgme(pgme,0),1005);     
  if (MyPosPgme(pgme)==0)
    { for (i=0;i<NumNodePgme(pgme);i++)       
	pvm_recv(-1,1005);  
      pvm_initsend(GlueEncoding); 
      for (i=0;i<NumNodePgme(pgme);i++)
	pvm_send(TidPgme(pgme,i),1006);    
    }
  pvm_recv(TidPgme(pgme,0),1006);     

}

/* TAHSIN
void *getPtFromId();
void sync2pgme_(pgme1Id,pgme2Id)
int *pgme1Id, *pgme2Id;
{pgme_s *pgme1=(pgme_s *)getPtFromId(*pgme1Id);
 pgme_s *pgme2=(pgme_s *)getPtFromId(*pgme2Id);
 Sync2Pgme(pgme1,pgme2);
}
*/

/* Sync For the SP2  
void Sync2Pgme(pgme1,pgme2)
     pgme_s *pgme1, *pgme2;
{
  int i;  
  pgme_s *pgme, *otherPgme;
  
  if (MyPosPgme(pgme1)!=-1) 
    {pgme=pgme1;
     otherPgme=pgme2;
   }
  else
    {pgme=pgme2;
     otherPgme=pgme1;
   }
  
  pvm_initsend(GlueEncoding);
  pvm_send(TidPgme(pgme,0),1005);     
  if (MyPosPgme(pgme)==0)
    { 
      pvm_send(TidPgme(otherPgme,0),1005);
      for (i=0;i<NumNodePgme(pgme)+1;i++) 
	{
	pvm_recv(-1,1005);
      }
      pvm_initsend(GlueEncoding); 
      for (i=0;i<NumNodePgme(pgme);i++)
	pvm_send(TidPgme(pgme,i),1006);   
      pvm_send(TidPgme(otherPgme,0),1006);
      pvm_recv(-1,1006);
      pvm_recv(-1,1006);
    }
  else
    {
      pvm_recv(TidPgme(pgme,0),1006);
    }
}
*/

/* nouvel essai 
void Sync2Pgme(pgme1,pgme2)
     pgme_s *pgme1, *pgme2;
{
  int i;
  int num;

  if (MyPosPgme(pgme1)==0)
    {
      num=NumNodePgme(pgme1)+NumNodePgme(pgme2)-1;
      for (i=0;i<num;i++)
	pvm_recv(-1,1005);      
      num=NumNodePgme(pgme1);
      pvm_initsend(GlueEncoding);
      for (i=1;i<num;i++)
	pvm_send(TidPgme(pgme1,i),1005);      
      num=NumNodePgme(pgme2);
      for (i=0;i<num;i++)
	pvm_send(TidPgme(pgme2,i),1005);
    }
  else
    {
      pvm_initsend(GlueEncoding);
      pvm_send(TidPgme(pgme1,0),1005);
      pvm_recv(-1,1005);  
    }

}

*/
/*
void Sync2Pgme(pgme1,pgme2)
     pgme_s *pgme1, *pgme2;
{
  int i;
  int alpha=0;

  pgme_s *tmp;

  if (strcmp(pgme1->name,pgme2->name)<0)
    {
      tmp=pgme1;
      pgme1=pgme2;
      pgme2=tmp;
    }


  if (MyPosPgme(pgme1)!=0)
    {
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&alpha,1,1);
      pvm_send(TidPgme(pgme1,0),1005);
      pvm_recv(TidPgme(pgme1,0),1006);
      pvm_upkint(&alpha,1,1);  
    }
  if (MyPosPgme(pgme1)==0)
    { 
      for (i=0;i<NumNodePgme(pgme1)+NumNodePgme(pgme2)-1;i++)       
	{pvm_recv(-1,1005);  
	 pvm_upkint(&alpha,1,1);
       }

      pvm_initsend(PvmDataDefault);
      pvm_pkint(&alpha,1,1);
      for (i=1;i<NumNodePgme(pgme1);i++)
	{      
	  pvm_send(TidPgme(pgme1,i),1006);
	}
      for (i=0;i<NumNodePgme(pgme2);i++)
	{      
	  pvm_send(TidPgme(pgme2,i),1006);
	}
    }
}
*/

/* */
char tout_gp[]="TousLesGp";
int _joined_gp=0;

void Sync2Pgme(pgme1,pgme2)
pgme_s *pgme1, *pgme2;
{
  int numnode;
  if (_joined_gp==0)
    {
      pvm_joingroup(tout_gp);
      _joined_gp++;
    }  
  numnode=NumNodePgme(pgme1)+NumNodePgme(pgme2);
  pvm_barrier(tout_gp,numnode);
}




int PrintPgme(pgme)
pgme_s *pgme;
{
#ifdef _verbose_flag_on_
fprintf(stderr,"\n-----------------");
fprintf(stderr,"\n nbNode=%i ",pgme->nbNode);
fprintf(stderr,"\n name=%s ",pgme->name);
fprintf(stderr,"\n tids ... ");
fprintf(stderr,"\n myPos=%i ",pgme->myPos);
fprintf(stderr,"\n-----------------\n");
#endif 

}


int Tid2PosPgme(pgme,tid)
pgme_s *pgme;
int tid;
{
  int i;

  for (i=0;i<pgme->nbNode;i++)
     if (pgme->tid[i]==tid)
       return(i);
  return(-1);
}






