#include <malloc.h>
#include <memory.h>

#include "util.h"
#include "regionX.h"
#include "regionEnum.h"

region_s *
Alloc_R_Enum(NumElem,globalCoord,distribution,mem_type)
     int                   NumElem;
     int                  *globalCoord;
     T_RegionDistribution  distribution;
     T_MemOp               mem_type;
{
  region_enum_s *r;
  r=Malloc_s(region_enum_s);
  r->type=R_Enum;
  r->distribution=distribution;
  r->size=NumElem;
  r->mem_type=mem_type;
  switch (r->mem_type){
  case Mem_Copy:
    r->globalCoord=(int *)malloc(sizeof(int) * NumElem);
    memcpy(r->globalCoord,globalCoord,sizeof(int) * NumElem);
    break;
  case Mem_Pointer:
    r->globalCoord=globalCoord;
    break;
  default:
    warning("Unkown Memory Operation");
    break;
  }
  return((region_s *)r);
}

void Free_R_Enum(region)
region_enum_s *region;
{
  if (region!=NULL)    
    switch (region->mem_type){
    case Mem_Copy:
      Free(region->globalCoord);
      break;
    case Mem_Pointer:	
      break;
    default:
      warning("Unkown Memory Operation");
      break;
    }  
  Free(region);
}

void 
Print_R_Enum(r)
region_enum_s *r;
{
  int i;

#if defined(DEBUG_T2MC)
  if (r!=NULL)
    {
      printf("\n");
      printf("\nRegion type: Enum ");
      printf("\n  distribution=%i",r->distribution);
      printf("\n  size=%i ",r->size);
      printf("\n  mem_type=%i ",r->mem_type);
      printf("\n  globalCoord=[");
      for (i=0;i<r->size;i++)
	printf(" %i",r->globalCoord[i]);
      printf(" ]\n");

    }
else
  printf("\n Region : NULL\n ");
#endif 
}


