
#include <stdio.h>

#include "util.h"
#include "pgme.h"
#include "liste.h"
#include "schedule.h"
#include "sd.h"
#include "global.h"
#include "communication.h"

/* la fct suivante en commentaire fonctionne correctement */
void
sendScheduleLocal(tab_sched_recv,
		  tab_sched_send,
		  pgme,
		  sched_send,
		  sched_recv)
     sched_s **tab_sched_recv, **tab_sched_send;
     pgme_s *pgme;
     sched_s **sched_send;
     sched_s **sched_recv;     
{
  int i;
  int me=MyPosPgme(pgme);
  int nproc=NumNodePgme(pgme);
  int i_1,proc;
  sched_s *sched;
  OneSched_s *Osched;
  sched_s *sched_sendPt;

  *sched_send=sched_sendPt=CreateSched(nproc);

  for (i_1=0;i_1<NumNodePgme(pgme);i_1++)
    {
      sched=tab_sched_send[i_1];
      for (proc=0;proc<sched->nproc;proc++)
	{
	  Osched=sched->sched[proc];
	  while (Osched!=NULL)
	    {
	      AddSched(*sched_send,proc,Osched->offset,Osched->size);
	      Osched=Osched->next;
	    }
	}
    }

  for (i=0;i<NumNodePgme(pgme);i++)
    {
      SendSched(pgme,i,tab_sched_recv[i],FLAG_SCHEDULE);      
    }
  
  *sched_recv=ReceiveSchedule(pgme);
}


/* avant des essai d optimization   
void
sendScheduleLocal(tab_sched_recv,
		  tab_sched_send,
		  pgme,
		  sched_send,
		  sched_recv)
     sched_s **tab_sched_recv, **tab_sched_send;
     pgme_s *pgme;
     sched_s **sched_send;
     sched_s **sched_recv;     
{
  int i;
  
  for (i=0;i<NumNodePgme(pgme);i++)
    {
      SendSched(pgme,i,tab_sched_send[i],FLAG_SCHEDULE);      
    }
  
  *sched_send=ReceiveSchedule(pgme);
  
  for (i=0;i<NumNodePgme(pgme);i++)
    {
      SendSched(pgme,i,tab_sched_recv[i],FLAG_SCHEDULE);      
    }
  
  *sched_recv=ReceiveSchedule(pgme);
}
*/


void
sendSchedule(tab_sched_recv,tab_sched_send,
	     pgme_recv,pgme_send)
     sched_s **tab_sched_recv, **tab_sched_send;
     pgme_s *pgme_recv, *pgme_send;
{
  sched_s *sched_send, *sched_recv;
  MListe_s *noeud;
  SD_s *sd;
  int i;

  for (i=0;i<NumNodePgme(pgme_send);i++)
    {
#ifdef _verbose_flag_on_
      printf("\nSend)Sending to proc %i ",i);
      PrintSched(tab_sched_send[i]);
#endif
      SendSched(pgme_send,i,tab_sched_send[i],FLAG_SCHEDULE);      
    }

  for (i=0;i<NumNodePgme(pgme_recv);i++)
    {
#ifdef _verbose_flag_on_
      printf("\nRcv)Sending to proc %i ",i);
      PrintSched(tab_sched_recv[i]);
#endif
      SendSched(pgme_recv,i,tab_sched_recv[i],FLAG_SCHEDULE);      
    }
}

sched_s *ReceiveSchedule(pgme1)
pgme_s *pgme1;
{
  int i;
  sched_s *sched=NULL;
  sched=RecvSched(pgme1,sched,FLAG_SCHEDULE);
  return(sched);
}


void
computeScheduleForSendAndRecv(
			      tab_sched_recv,tab_sched_send,
			      liste_sd,
			      pgme_recv,pgme_send)
sched_s **tab_sched_recv, **tab_sched_send;
liste_s *liste_sd;
pgme_s *pgme_recv, *pgme_send;
{
  sched_s *sched_send, *sched_recv;
  MListe_s *noeud;
  SD_s *sd;
  int i;

#ifdef _verbose_flag_on_
  printf("\n NumNodePgme(pgme_send)=%i ",NumNodePgme(pgme_send));
  printf("\n NumNodePgme(pgme_recv)=%i ",NumNodePgme(pgme_recv));
  printf("\n");
  PrintListe(liste_sd,print1_SD);
  printf("\n");
#endif


  noeud=PremierListe(liste_sd);
  while (noeud!=NULL)
    {
      sd=(SD_s *)noeud->elem;
      sched_recv=tab_sched_recv[sd->Proc[0]];
      AddSched(sched_recv,sd->Proc[1],sd->Offset[0],sd->Size); 

      sched_send=tab_sched_send[sd->Proc[1]];
      AddSched(sched_send,sd->Proc[0],sd->Offset[1],sd->Size); 
      noeud=noeud->suiv;
  }
#ifdef _verbose_flag_on_ 
  printf("\n");
  printf("\n--------------- Recv ---------------------");
  for (i=0;i<NumNodePgme(pgme_recv);i++)
    {printf("\n--- %i ---",i);
      PrintSched(tab_sched_recv[i]);
   }

  printf("\n--------------- Send ---------------------");
  for (i=0;i<NumNodePgme(pgme_send);i++)
    {printf("\n--- %i ---",i);
      PrintSched(tab_sched_send[i]);
   }
#endif 
}


sched_s *CreateSched(nproc)
     int nproc;
{
  sched_s *sched;
  int i;
  _affirmation_(("nproc>0",nproc>0));
  
  sched=Malloc_s(sched_s);
  sched->sched=(OneSched_s **)malloc(sizeof(OneSched_s *)*nproc);
  sched->size=(int *)malloc(sizeof(int)*nproc);
  sched->nproc=nproc;
  for (i=0;i<nproc;i++)
    {
      sched->size[i]=0;
      sched->sched[i]=NULL;
    }
  return(sched);
}

sched_s *AddSched(sched,proc,offset,size)
     sched_s *sched;
     int proc;
     int offset;
     int size;
{
  int i;
  OneSched_s *Osched;

  _affirmation_(("proc>=0",proc>=0));
  _affirmation_(("sched!=NULL", sched!=NULL));
  _affirmation_(("proc<nproc",proc<sched->nproc));
  
  Osched=Malloc_s(OneSched_s);
  Osched->offset=offset;
  Osched->size=size;

  Osched->next=sched->sched[proc];
  sched->sched[proc]=Osched;
  (sched->size[proc])++;

  return(sched);
}

void FreeSched(sched)
sched_s *sched;
{
 int proc;
 OneSched_s *Osched, *NextOsched;
  if (sched!=NULL)
    {
      for (proc=0;proc<sched->nproc;proc++)
	{Osched=sched->sched[proc];
	 NextOsched=Osched;
	 while (Osched!=NULL)
	   {NextOsched=Osched->next;
	    free(Osched);
	    Osched=NextOsched;
	   }
       }
      free(sched->size);
      free(sched->sched);
      sched->nproc=-1;
      free(sched); 
      sched=NULL;
    }
}

void PrintSched(sched)
sched_s *sched;
{
  int proc;
  OneSched_s *Osched;  

#if defined(_verbose_flag_on_)  
  printf("\n-- Sched --\n nproc=%i ",sched->nproc);
  for (proc=0;proc<sched->nproc;proc++)
    {printf("\n [%i] size=%i ",proc,sched->size[proc]);
     Osched=sched->sched[proc];
     while (Osched!=NULL)
       {
	 printf(" (%i,%i)",Osched->offset,Osched->size);
	 Osched=Osched->next;
       }
    }
  printf("\n");
#endif 
}

int PrintSched1(sched)
sched_s *sched;
{
  int proc;
  OneSched_s *Osched;  
  int size=0;
  
  for (proc=0;proc<sched->nproc;proc++)
    {
     Osched=sched->sched[proc];
     while (Osched!=NULL)
       {
	 size+=Osched->size;
	 Osched=Osched->next;
       }
    }
#ifdef DEBUG_T2MC
  printf("\n-- Sched -- nproc=%i -- size %i %i  ",sched->nproc,sched->size,size);
#endif 
}





