#include <stdio.h>
#include "util.h"
#include "zm.h"

ZM_s *alloc_ZM()
{ZM_s *zm;
 zm=(ZM_s *)malloc(sizeof(ZM_s));
 return(zm);
}

void free_ZM(zm)
ZM_s *zm;
{
Free(zm);
}


ZM_s *init_ZM(globalOffset,proc,offset,size)
int  globalOffset,proc,offset,size;
{ZM_s *z;
 z=alloc_ZM();
 set_ZM(z,globalOffset,proc,offset,size);
 return(z);
}

ZM_s *set_ZM(this,globalOffset,proc,offset,size)
ZM_s *this;
int  globalOffset,proc,offset,size;
{this->globalOffset=globalOffset;
 this->proc=proc;
 this->offset=offset;
 this->size=size;
 _affirmation_(("this->globalOffset>=0",this->globalOffset>=0));
 _affirmation_(("this->proc>=0",this->proc>=0));
 _affirmation_(("this->offset>=0",this->offset>=0));
 _affirmation_(("this->size>0",this->size>0));

 return(this);
}

ZM_s *split_offset_ZM(this,offset)
ZM_s *this;
int offset;
{int size=this->offset-offset;
 ZM_s *z=init_ZM(this->globalOffset,this->proc,offset,size);
 set_ZM(this,this->globalOffset+size,this->proc,this->offset,this->size-size);
 return(z);
}

ZM_s *split_size_ZM(this,size)
ZM_s *this;
int size;
{int offset=this->offset+size;
 return(split_offset_ZM(this,offset));
}

void trunc_ZM(this,size)
ZM_s *this;
int  size;
{
 _affirmation_(("this->size>=size",this->size>=size));
 _affirmation_(("size>=0",size>=0));
 set_ZM(this,this->globalOffset,this->proc,this->offset,size);
}

void trunc_reste_ZM(this,size)
ZM_s *this;
int  size;
{
 set_ZM(this,
	this->globalOffset+size,
	this->proc,
	this->offset+size,
	this->size-size);
}

void printGlobalOffset_ZM(this)
ZM_s *this;
{
  if (this!=NULL)
    printf(" %i ",this->globalOffset);
}


void print_ZM(this)
     ZM_s *this;
{
  if (this!=NULL)
    {
#if defined(_verbose_flag_on_)
      printf("\n ---------- \n set_ZM ");
      printf("\n     globalOffset=%i ",this->globalOffset);
      printf("\n     proc        =%i ",this->proc);
      printf("\n     offset      =%i ",this->offset);
      printf("\n     size      =%i ",this->size);
      printf("\n");
#endif 
    }
}

void print1_ZM(this)
     ZM_s *this;
{
  if (this!=NULL)
    {
      fprintf(stderr,"(%i,%i,%i,%i) ",this->globalOffset,this->proc,this->offset,this->size);
    }
}
 
int TestGlobalOffset_ZM(zm1,zm2)
ZM_s *zm1;
ZM_s *zm2;
{
 _affirmation_(("zm1!=NULL",zm1!=NULL));
 _affirmation_(("zm2!=NULL",zm2!=NULL));
 _dprint_(("%i",globalOffset_ZM(zm1)));
 _dprint_(("%i",globalOffset_ZM(zm2)));
 if (globalOffset_ZM(zm1) > globalOffset_ZM(zm2))
   return(1);
 else
   return(0);
}


