
/* $Id: t2_rtreeindex.h,v 1.1 2000/03/08 02:54:30 chialin Exp $ */

/* t2_rtreeindex.h */

#ifndef _T2_RTREE_INDEX_H_
#define _T2_RTREE_INDEX_H_

#include	"t2_header.h"
#include	"t2_rtree.h"
#include	"t2_index.h"

//////////////////////////////////////////////////////////////////////////////
//
// struct T2_StaticRTreeIndexLeafNode
//
//////////////////////////////////////////////////////////////////////////////
class T2_StaticRTreeIndexLeafNode {
public:
  T2_StaticRTreeIndexLeafNode() :mbr(), fid(0), offset(0), size(0), arg() {};
  T2_StaticRTreeIndexLeafNode(const T2_StaticRTreeIndexLeafNode& l)
	:mbr(l.mbr), fid(l.fid), offset(l.offset), size(l.size), arg(l.arg) {};
  T2_StaticRTreeIndexLeafNode& operator =(const T2_StaticRTreeIndexLeafNode& l)
	{ mbr = l.mbr; fid = l.fid; offset = l.offset; size = l.size; 
	  return *this; };

  T2_Box mbr;
  u_int fid;
  off_t offset;
  size_t size;
  T2_UsrArg arg;
};



//////////////////////////////////////////////////////////////////////////////
//
// T2_StaticRTreeIndex
//
// A wrapper for the T2 static r-tree that supports the interface
// dictated by the base class, T2_Index (see t2_index.h for more details).
//
//////////////////////////////////////////////////////////////////////////////
class T2_StaticRTreeIndex: public T2_Index {
public:
  T2_StaticRTreeIndex(const T2_Array<int>& fd);
  ~T2_StaticRTreeIndex() {};

  // query methods
  bool isValid() const { return valid; };

  // virtual functions defined by T2_Index
  T2_UDFRet fetchInit(const T2_System& system, const T2_Box& qr);
  T2_UDFRet fetch(const T2_System& system, const T2_Box& qr,
		  bool& eod, T2_Box& mbr, T2_ClusterAuxInfoWriter& info,
		  T2_VArray<T2_BlockRequest>& chk);

protected:
  T2_Array<T2_StaticRTree> rtrees;
  bool valid;
  u_int cur_tree;		// the current rtree doing search (ie fetch) on

private:
};



#endif	/* ! _T2_RTREE_INDEX_H_ */
