
/* $Id: w-gistfile.C,v 1.4 1999/06/30 19:55:57 chialin Exp $ */

/* w-gistfile.C */


#include	<memory.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	"w_gistfile.h"


/////////////////////////////////////////////////////////////////////////////
//
// variables
//
/////////////////////////////////////////////////////////////////////////////
static char magic[] = "Gist data file";

/////////////////////////////////////////////////////////////////////////////
//
// W_GistFile methods
//
/////////////////////////////////////////////////////////////////////////////
rc_t
W_GistFile::attach(int fd)
{
  if (isOpen || fd < 0) {	// already a file is open, return an error
     return eFILEERROR;
  }

  fileHandle = fd;		// assign 
  lseek(fd, 0, SEEK_SET);	// rewind to begin of file

  // Verify that the magic words are there
  char page[SM_PAGESIZE];
  read(fileHandle, page, SM_PAGESIZE);
  if (memcmp(page, magic, sizeof(magic))) {
	return(eFILEERROR); // error: magic words not found
  }

  // success!
  isOpen = true;
  attached = true;
  fileSize = (lseek(fileHandle, 0, SEEK_END) + 1) / SM_PAGESIZE;
        // + 1: 0-based offset
  return(RCOK);
}


rc_t
W_GistFile::close()
{
  W_DO(flush());
  isOpen = false;
  if (attached == true) {
     attached = false;
     return RCOK;
  }
  return ::close(fileHandle);
}

