
/* t2_cluster.h */

#ifndef _T2_CLUSTER_H_
#define _T2_CLUSTER_H_


#include	"t2_header.h"
#include	"t2_clusterreq.h"
#include	"t2_shape.h"


/////////////////////////////////////////////////////////////////////
//
// T2_Cluster
//
/////////////////////////////////////////////////////////////////////
class T2_Cluster {
public:
  T2_Cluster(T2_ClusterRequest&);
  ~T2_Cluster() {};

  // query methods
  u_int getNumberBlocks() const { return bufs.getNumberElements(); };

  // const access method
  const char* getDataPointer(u_int i) const { return bufs[i].data; };
  size_t getDataSize(u_int i) const { return bufs[i].nbytes; };

  // non-const access method
  char*& getDataPointer(u_int i) { return bufs[i].data; };
  size_t& getDataSize(u_int i) { return bufs[i].nbytes; };

protected:
  struct Buf { char* data; size_t nbytes;
		Buf() { data = NULL; nbytes = 0; };
		~Buf() {};
  };

  T2_Array<Buf> bufs;

private:
};



#endif	/* _T2_CLUSTER_H_ */
