
/* $Id: t2_dataset.h,v 1.4 2000/02/04 00:19:36 chialin Exp $ */

/* t2_dataset.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 5/4/98
 * Dataset classes
 */

#ifndef _T2_DATASET_H_
#define _T2_DATASET_H_


#include	"t2_header.h"
#include	"t2_cluster.h"
#include	"t2_usrarg.h"
#include	"t2_shape.h"
#include	"t2_system.h"
#include	"t2_prj.h"
#include	"t2_index.h"


// forward declaration
class T2_Iterator;

/////////////////////////////////////////////////////////
//
// T2_Dataset
//
/////////////////////////////////////////////////////////
class T2_Dataset {
public:
  T2_Dataset() {};
  virtual ~T2_Dataset() {};

  // some user-defined functions
  virtual T2_UDFRet genIterator(const T2_System& system, T2_IteratorID i,
			       const T2_Cluster& c,
			       const T2_Box& mbr, T2_ClusterAuxInfoReader& meta,
			       const T2_Box& iqr, const T2_Region& tilereg,
				T2_ProjectFuncObj& prj, T2_Iterator*& iterp)= 0;

protected:
private:
};



/////////////////////////////////////////////////////////
//
// T2_Dataset constructors
//
/////////////////////////////////////////////////////////
typedef T2_UDFRet (T2_DatasetConstructor)
		  (const T2_System& system,
		   const T2_Array<int>& dfd, const T2_Array<int>& mdfd,
		   T2_Dataset*& dsp);
typedef T2_UDFRet (*T2_DatasetConstructorPtr)
		  (const T2_System& system,
		   const T2_Array<int>& dfd, const T2_Array<int>& mdfd,
		   T2_Dataset*& dsp);



/////////////////////////////////////////////////////////
//
// T2_Iterator
//
// A base class for dataset iterators.
//
/////////////////////////////////////////////////////////
class T2_Iterator {
public:
  T2_Iterator() {};
  virtual ~T2_Iterator() {};

  // virtual functions
  virtual T2_UDFRet getNextElement(const T2_System& system,
				   const T2_Cluster& c,
				   bool& eod, const void*& e, T2_Point& coord);

protected:
private:
};


inline T2_UDFRet
T2_Iterator::getNextElement(const T2_System& system, const T2_Cluster& c,
			    bool& eod, const void*& e, T2_Point& coord)
{
  eod = true;
  return T2_UDFRet_OK;
}



#endif	/* _T2_DATASET_H_ */
