
/* $Id: t2_prj.h,v 1.2 2000/01/05 22:43:51 chialin Exp $ */

/* t2_prj.h */

/*
 * Chialin Chang, chialin@cs.umd.edu, 5/4/98
 * projection function classes
 */


#ifndef _T2_PRJ_H_
#define _T2_PRJ_H_


#include	"t2_header.h"
#include	"t2_usrarg.h"
#include	"t2_shape.h"
#include	"t2_system.h"


///////////////////////////////////////////////////////////////////////////
//
// T2_ProjectFuncObj
//
///////////////////////////////////////////////////////////////////////////
class T2_ProjectFuncObj {
public:
  T2_ProjectFuncObj() {};
  virtual ~T2_ProjectFuncObj() {};

  // virtual functions
  virtual T2_UDFRet project(const T2_System& system,
			    const T2_Box& iqr, const T2_Region& oqw,
			    const T2_Point& input_pt, 
			    bool& succeed, T2_Region& output_rg) = 0;
  virtual u_int getNumberInputDimensions() = 0;
  virtual u_int getNumberOutputDimensions() = 0;

  // use the virtual project method to project a box into another box
  virtual T2_UDFRet projectBox(const T2_System& system, const T2_Box& inbox,
			       bool& succeed, T2_Box& outbox);

protected:
private:
};



///////////////////////////////////////////////////////////////////////////
//
// T2_ProjectFuncObj
//
///////////////////////////////////////////////////////////////////////////
typedef T2_UDFRet 
	(T2_ProjectFuncConstructor)(const T2_System&, T2_UsrArgReader&,
				    T2_ProjectFuncObj*&);
typedef T2_UDFRet 
	(*T2_ProjectFuncConstructorPtr)(const T2_System&, T2_UsrArgReader&,
				    T2_ProjectFuncObj*&);



#endif	/* _T2_PRJ_H_ */
