
/* $Id: t2_queryinfo.h,v 1.4 2000/03/14 23:26:23 chialin Exp $ */

/* t2_queryinfo.h */

#ifndef _T2_QUERYINFO_H_
#define _T2_QUERYINFO_H_

#include	"t2_header.h"
#include	"t2_system.h"
#include	"t2_qspec.h"
//#include	"t2_qplan.h"


// forward declaration
class T2_QEnv;
class T2_QQPlan;

//////////////////////////////////////////////////////////////////////
//
// T2_QueryInfo
//
// A class that provides query information to the user-defined
// customization code.
//
//////////////////////////////////////////////////////////////////////
class T2_QueryInfo {
friend class T2_QEnv;
public:
  T2_QueryInfo(T2_QQPlan*& qp);
  ~T2_QueryInfo() {};

  // return information on tiles
  T2_Iteration getNumberTiles() const;
  T2_Iteration getCurrentTileNumber() const;

  // return information about query
//  u_int getQuerySpecificationEndian() const { return qspec->getQSpecEndian(); };
  u_int getExpectedQueryOutputEndian() const 
			{ return qspec->getOutputSpec().getOutputEndian(); };

  // return information on system object
  u_int getNumberNodes() const { return system->getNumberNodes(); };
  T2_ProcID getMyNode() const { return system->getMyNode(); };
  u_int getBackEndEndian() const { return system->getBackEndEndian(); };
  const T2_System& getSystem() const { return *system; };

protected:
//  T2_QEnv& qenv;		// a reference to the query environment
  T2_QQPlan*& qqplan;		// a reference to the query plan
  const T2_System* system;
  const T2_QSpec* qspec;

  // set system pointer
  void setSystem(const T2_System& s) { system = &s; };

  // set query specification pointer
  void setQuerySpec(const T2_QSpec& q) { qspec = &q; };

private:
};


inline
T2_QueryInfo::T2_QueryInfo(T2_QQPlan*& qp)
		: qqplan(qp), system(NULL), qspec(NULL)
{
}

// The following is moved to queryinfo.C to avoid bad include dependency
//
//inline T2_Iteration
//T2_QueryInfo::getNumberTiles() const
//{
//  if (qqplan == NULL)
//     return 0;
//  return qqplan->getNumberSubplans();
//}
//
//inline T2_Iteration
//T2_QueryInfo::getCurrentTileNumber() const
//{
//  if (qqplan == NULL)
//     return 0;
//  return qqplan->getCurrentIteration();
//}



#endif	/* ! _T2_QUERYINFO_H_ */
