
/* bbuf.C */


#include	"t2_bbuf.h"


///////////////////////////////////////////////////////////////////
//
// T2_BBuffer methods
//
///////////////////////////////////////////////////////////////////
T2_BBuffer::T2_BBuffer()
{
  buf = NULL;
  bufsize = 0;
}


T2_BBuffer::~T2_BBuffer()
{
  t2_Assert (buf == NULL);
}


T2_BBuffer::T2_BBuffer(const T2_BBuffer& b)
{
  t2_Assert (b.bufsize == 0);
}


T2_BBuffer&
T2_BBuffer::operator =(const T2_BBuffer& b)
{
  t2_Assert (b.bufsize == 0);
  t2_Assert (bufsize == 0);
  return *this;
}


size_t
T2_BBuffer::alloc(size_t n)
{
  t2_Assert (buf == NULL);
  if (n == 0 || ((buf = new char[n]) == NULL)) {
     buf = NULL;
     bufsize = 0;
     return 0;
  }
  bufsize = n;
  return n;
}


void
T2_BBuffer::release()
{
  t2_Assert (buf != NULL);
  delete [] buf;
  buf = NULL;
  bufsize = 0;
}
