
/* bcache.C */

/*
 * Chialin Chang, chialin@cs.umd.edu, 6/18/98
 */


#include	"t2_bcache.h"
#include	"t2_clusterreq.h"


///////////////////////////////////////////////////////////////////////
//
// T2_BlockCache methods
//
///////////////////////////////////////////////////////////////////////
bool
T2_BlockCache::insert(T2_PhyBlockRequest* b)
{
  t2_Assert (b != NULL);
  if (getCacheSize() == 0 ||			// cache size is 0
      b->getNumberStaticOwners() < 2) {		// only 1 statis owner
     b->kill();					// kill directly
     return false;				// no need to cache at all
  }

# ifdef T2_ASSERTION
     u_int i = 
# endif
  search(b);
  t2_Assert (i == getNumberBlockRequests());    // assert no duplicates
  if (cache.isFull())
     overflow(b);
  else
     cache.in(b);
  return true;
}


void
T2_BlockCache::overflow(T2_PhyBlockRequest* b)
{
  t2_Assert (cache.isFull());
  t2_Assert (b != NULL);

  // for now, use the easiest implementation, always replace the 1st entry
  cache[0]->kill();
  cache[0] = b;
}
