
/* $Id: read-dataset-catalog-disk-assignment.C,v 1.1 2000/02/09 21:51:46 chialin Exp $ */

/* read-dataset-catalog-disk-assignment.C */


#include	"t2_header.h"
#include	"t2_dscat.h"
#include	"t2_diskassign.h"


//////////////////////////////////////////////////////////////////////////
//
// main program
//
//////////////////////////////////////////////////////////////////////////
main(int argc, char** argv)
{
  if (argc < 5) {
     cout << "Usage: " << argv[0]
	  << " <hostname> <rank> <disk assignment file> <dataset catalog file> [<dataset catalog file> ...]"
	  << endl;
     return -1;
  }

  int ac = 1;
  const char* hostname = argv[ac++];

  int atoi_err;
  int mynode = t2_atoi(argv[ac++], &atoi_err);
  if (atoi_err != 0 || mynode < 0) {
     t2_err_ret(__FILE__, __LINE__,
	"ERROR: invalid processor rank '%s'", argv[ac-1]);
     return -1;
  }

  T2_DiskAssignmentFile diskassign;
  diskassign.open(hostname, mynode, argv[ac++]);
  if (!diskassign)  		// open file failed
     return -1;
  cout << "Printing out disk assignment file:" << endl
       << diskassign << endl;

  T2_DSCatalog dscat;
  for (int i=ac; i<argc; i++) {
     cout << "Reading file " << argv[i] << " =============" << endl;;

     switch (diskassign.getAssignmentType()) {
	case T2_DiskAssignmentFile::assign_error:    // error
		t2_err_quit(__FILE__, __LINE__,
			"ERROR: error assignment type");
		break;
	case T2_DiskAssignmentFile::assign_disk_ids: // overwrite disk assignmt.
		dscat.openDiskID(argv[i], diskassign.getDiskIDAssignment());
		break;
	case T2_DiskAssignmentFile::assign_proc_ids: // overwrite proc assignmt.
		dscat.openProcID(argv[i], diskassign.getProcIDAssignment());
		break;
     }
     if (!dscat)		// error
         continue;

     cout << dscat << endl;
     cout << endl;
     dscat.close();
  }

  return 0;
}

